#!/usr/X11R6/bin/wish8.0

# This is an mpeg_play wrapper so users can actually see the anim,
# more than once, select a dithering to use, etc.
#
# Written by Alexei Rodriguez (alexei@cis.ufl.edu) and 
# Bradley C. Spatz (bcs@cis.ufl.edu). 10oct93
#
# Modified by Athanasios Migdalas <migdalas@dias.ergasya.tuc.gr> August 20, 1999
# ...
# so that users can actually select files to play through a Dialog Box.
# Command line preserved though.
# Interface layout changed.

# set filea to the arg that is passed (file to view).
# Setting quiet to 1 ensures we do not get the default eoj stats
# mpeg_play displays. I have dither set to 15 so that the a correct
# cmd will be built everytime. Otherwise it would default to 0 and
# thus a command line would be built with "-dither" but no option,
# so mpeg_play would assume the file name was the dither type. Wrong.

#######################################################################
##       CHANGE THIS TO THE mpeg_play PATH in YOYR SYSTEM            ##
#######################################################################

set MPEGPATH /usr/X11R6/bin/

#######################################################################
##   CHANGE THIS TO THE DIRECTORY OF INSTALLATION OF TkMpeg          ##
#######################################################################

set MSCCINSTALLDIR /home/sakis/Sakis/Programs/Tcl-Tk/TkMpeg

############ NO NEED TO TOUCH BELOW THIS LINE #########################
#######################################################################

proc OpenError {} {
    global tit
    set eb [tk_messageBox -title $tit \
            -message "Error: File README.tkmpeg doesn't seem to exist. \
                     Can't be opened!" \
		-icon error -type ok]
}

## Procedure from "Practical Programming in Tcl and Tk" ##
## By Brent B. Welch                                    ##
## A book that I wormly recommend                       ##
proc ScrollableText { fr args} {
    frame $fr
    eval {text $fr.txt \
	      -xscrollcommand [list $fr.xscroll set] \
              -yscrollcommand [list $fr.yscroll set]} $args
          scrollbar $fr.yscroll -orient vertical \
        	 -command [list $fr.txt yview]
          scrollbar $fr.xscroll -orient horizontal \
        	 -command [list $fr.txt xview]
          grid $fr.txt $fr.yscroll -sticky news
          grid $fr.xscroll -sticky news
          grid rowconfigure $fr 0 -weight 1
          grid columnconfigure $fr 0 -weight 1
          return $fr.txt
}  
###########################################################

proc ShutHelp {} {
     global vh
     wm withdraw $vh
}

proc Find {argWhat} {
     global ht
    set start [$ht search -count cnt -exact -- $argWhat 1.0 end ]
    $ht tag add sel "$start linestart" "$start +$cnt chars"
    $ht see $start
}

proc HelpMessage {} {
    global vh bm1 MSCCINSTALLDIR tit gif1 gif3 ht
    if [winfo exists .h] {
       wm deiconify .h
       focus .h
    } else {
       set vh [toplevel .h ]
       wm title .h $tit
       wm iconbitmap $vh @$bm1
        set vh2 [frame .h.h1 -background blue -relief solid]
        pack $vh2 -side top -fill x
	set im1 [image create photo -file $gif1]
        set im2 [image create photo -file $gif3]
	set him1 [label $vh2.l -image $im1]
        set him2 [label $vh2.l2 -image $im2]
        set him3 [label $vh2.l3 -text "  tkmpeg *  v 0.001 *  File Selector for mpeg_play" \
		      -background blue -foreground yellow]
	set vh3 [frame .h.h2]
        pack $vh3 -side top -fill x
        set vh4 [frame .h.h3]
        pack $vh4 -side top -fill x
       set hp [button $vh4.can -text Cancel -width 12 -command ShutHelp]
	set what [button $vh3.wh -text "What ?" -width 12 -command {Find "INTRODUCTION:"}]
        set install [button $vh3.ins -text "Install ?" -width 12 -command {Find "INSTALLATION:"}]
        set use [button $vh3.us -text "Use ?" -width 12 -command {Find "USE:"}]
        set buts [button $vh3.bts -text "Options ?" -width 12 -command {Find "Options."}]
        set playM [button $vh3.plm -text "Quit?" -width 12 -command {Find "Quit"}]
        set warr [button $vh4.war -text "Warranty ?" -width 12 -command {Find "WARRANTY:"}]
        set copy [button $vh4.cop -text "Copying ?" -width 12 -command {Find "COPYING:"}]
        set probl [button $vh4.prob -text "Problem ?" -width 12 -command {Find "REQUIREMENTS:"}]
        set why [button $vh4.why -text "More Help ?" -width 12 -command {Find "OTHER:"}]
       set ht [ScrollableText .h.hp -width 60 -height 10 -relief sunken]
       pack $vh2.l $vh2.l2 $vh2.l3 -padx 0 -side left
       pack $what $install $use $buts $playM -side left
       pack $warr $copy $probl $why $hp -side left
       pack .h.hp -side bottom -fill both -expand true
       focus $vh
        set hlpFile "README.tkmpeg"
	set hlpFile [file join $MSCCINSTALLDIR $hlpFile]
	if [catch {open $hlpFile} in] {
           OpenError
	} else {
          $ht configure -state normal
	  $ht insert end [read $in]
          $ht configure -state disabled
          close $in
	}
    }
}

# This procedure, mpeg, will build a list containing the command
# we will exec, the options the user selects, and finally the file
# to be viewed. Note: if mpeg_play is not in your path, you may 
# want to specify it. Also, I have commented out the 'puts stdout '
# line that I was using to debug the script. If you want to see what
# is going to get exec'ed, uncomment the line.

proc MpegPlay {} {
	global quiet dither nob nop filea MPEGPATH id

        set cmd [file join $MPEGPATH mpeg_play] 
     
	if {$quiet == "1"} {
		lappend cmd "-quiet"
	}
        if {$nob == "1"} {
		lappend cmd "-nob"
	}
	if {$nop == "1"} {
		lappend cmd "-nop"
	}
	if {$dither != "15"} {
		lappend cmd "-dither"
	}
	if {$dither == "1"} {
		lappend cmd "ordered"
	}
	if {$dither == "2"} {
		lappend cmd "ordered2"
	}
	if {$dither == "3"} {
		lappend cmd "mbordered"
	}
	if {$dither == "4"} {
		lappend cmd "fs4"
	}
	if {$dither == "5"} {
		lappend cmd "fs2"
	}
	if {$dither == "6"} {
		lappend cmd "fs2fast"
	}
	if {$dither == "7"} {
		lappend cmd "hybrid"
	}
	if {$dither == "8"} {
		lappend cmd "hybrid2"
	}
	if {$dither == "9"} {
		lappend cmd "2x2"
	}
	if {$dither == "10"} {
		lappend cmd "gray"
	}
	if {$dither == "11"} {
		lappend cmd "color"
	}
	if {$dither == "12"} {
		lappend cmd "none"
	}
	if {$dither == "13"} {
		lappend cmd "mono"
	}
	if {$dither == "14"} {
		lappend cmd "threshold"
	}
	lappend cmd $filea
	puts stdout $cmd
        set id [eval "exec $cmd"]
}



proc EnableButtons {} {
     global cb1 cb2 cb3 dbm1 dbm2 en
     $cb1 configure -state normal
     $cb2 configure -state normal
     $cb3 configure -state normal
     $dbm1 configure -state normal
     $dbm2 configure -state normal
     $en configure -state disabled
}

proc OpenFile {} {
    global inFile filea en
    set typelist { 
                  {"Mpeg Files" {".mpg"}} 
                  {"All Files" {*}}
    }
    set of [tk_getOpenFile -title "Select Mpeg File" -initialdir ~/. -defaultextension mpg \
                           -filetypes $typelist]
    if {$of != ""} {
       set filea $of
       set inFile $filea
       $en configure -state normal
       EnableButtons
   }
}

proc Quit {} {
     global id
    if {$id != -100} {
       exec kill id
    }
       exit
}


set filea ""
set inFile ""
set id -100

set quiet 0
set dither 15

set b [frame .mnbar]
set bf [menubutton $b.file -relief raised -text File -menu $b.file.menu -width 9]
    set m [menu $b.file.menu -tearoff 0]
    set mn [$m add command -label "Open File" -command OpenFile]
set dbm2 [button  $b.play -relief raised -text "Play Anim" -state disabled -command MpegPlay]
set dbm1 [menubutton $b.mbutton -relief raised -text "Dithering" -menu $b.mbutton.menu -state disabled]
button  $b.exit -relief raised -text "Quit" -command Quit -width 9
button $b.help -text Help -command HelpMessage -width 9
pack $b -side top -fill x
pack $b.file $dbm2 $dbm1 $b.exit -side left
pack $b.help -side right

set f [frame .dirFile]
set lb [label $f.lbl -text "Mpeg File:" -padx 0]
set en [entry $f.dir -width 20 -relief sunken -textvariable inFile]
pack $f -side top -fill x
pack $f.lbl -side left
pack $f.dir -side left -fill x -expand true


set f2 [frame .chbs]
set cb1 [checkbutton $f2.nob -text "No B Frames" -state disabled]
set cb2 [checkbutton $f2.nop -text "No P Frames" -state disabled]
set cb3 [checkbutton $f2.quiet -text "Quiet" -state disabled]
pack $f2 -side top -fill x
pack $cb1 $cb2 $cb3 -side left -fill x -expand true

# This cascade menu may look a bit goofy. It works and I did not
# want to assume everybody had patched the Tk libraries to get 
# "prettier" cascade menus. Our global variable for the radiobuttons
# is dither. Thus, only one button can be selected. No Dither is the
# default.

menu $b.mbutton.menu 
$b.mbutton.menu add cascade -label "Dithering" -menu $b.mbutton.menu.more
menu $b.mbutton.menu.more
$b.mbutton.menu.more add radiobutton -label "Ordered" -variable dither -value 1
$b.mbutton.menu.more add radiobutton -label "Fast Ordered" -variable dither -value 2
$b.mbutton.menu.more add radiobutton -label "Macroblock Ordered" -variable dither -value 3
$b.mbutton.menu.more add radiobutton -label "Floyd-Steinberg with 4 error values" -variable dither -value 4
$b.mbutton.menu.more add radiobutton -label "Floyd-Steinberg with 2 error values" -variable dither -value 5
$b.mbutton.menu.more add radiobutton -label "Fast Floyd-Steinberg with 2 error values" -variable dither -value 6
$b.mbutton.menu.more add radiobutton -label "Hybrid" -variable dither -value 7
$b.mbutton.menu.more add radiobutton -label "hybrid with error propagation" -variable dither -value 8
$b.mbutton.menu.more add radiobutton -label "2x2" -variable dither -value 9
$b.mbutton.menu.more add radiobutton -label "Grayscale" -variable dither -value 10
$b.mbutton.menu.more add radiobutton -label "Color 24bit only" -variable dither -value 11
$b.mbutton.menu.more add radiobutton -label "No display, no dither" -variable dither -value 12
$b.mbutton.menu.more add radiobutton -label "Monochrome" -variable dither -value 13
$b.mbutton.menu.more add radiobutton -label "Floyd-Steinberg Simple, monochrome only" -variable dither -value 14
$b.mbutton.menu.more add radiobutton -label "No dithering" -variable dither -value 15


set bm1 [file join $MSCCINSTALLDIR macstar.xbm]
set gif1 [file join $MSCCINSTALLDIR macstar.gif]
set gif3 [file join $MSCCINSTALLDIR mscclogo.gif]
set tit "Mpeg File Selector for mpeg_play"

wm title . "TkMpeg"
wm minsize . 60 12
wm iconbitmap . @$bm1


# Check to see if started with command line argument

if {$argc != 0} {
    set filea [lindex $argv 0]
    set inFile $filea
    $en configure -state normal
    EnableButtons
}
